<?php

namespace OXI_IMAGE_HOVER_PLUGINS\Modules\Carousel;

/**
 * Description of General
 *
 * @author biplo
 */
use OXI_IMAGE_HOVER_PLUGINS\Page\Create as Create;

class Carousel extends Create {

    public function Admin_header() {
        ?>
        <div class="oxi-addons-wrapper">
            <div class="oxi-addons-import-layouts">
                <h1>Carousel or Slider › Create New</h1>
                <p> Select Image Hover layouts, Gives your Image Hover name and create new Image Hover.</p>
            </div>
        </div>
        <?php
    }

    public function Import_header() {
        ?>
        <div class="oxi-addons-wrapper">
            <div class="oxi-addons-import-layouts">
                <h1>Carousel or Slider › Import Templates</h1>
                <p> Select Image Hover layouts, Import Templates for future Use.</p>
            </div>
        </div>
        <?php
    }

    public function create_new() {
        echo __('<div class="modal fade" id="oxi-addons-style-create-modal" >
                        <form method="post" id="oxi-addons-style-modal-form">
                            <div class="modal-dialog modal-sm">
                                <div class="modal-content">
                                    <div class="modal-header">                    
                                        <h4 class="modal-title">New Carousel Style</h4>
                                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                                    </div>
                                    <div class="modal-body">
                                        <div class=" form-group row">
                                            <label for="addons-style-name" class="col-sm-6 col-form-label" oxi-addons-tooltip="Give your Shortcode Name Here">Name</label>
                                            <div class="col-sm-6 addons-dtm-laptop-lock">
                                                <input class="form-control" type="text" value="" id="style-name"  name="style-name">
                                            </div>
                                        </div>
                                        <div class="form-group row d-none">
                                            <label for="oxi-tabs-link" class="col-sm-5 col-form-label" title="Select Layouts">Layouts</label>
                                            <div class="col-sm-7">
                                                <div class="btn-group" data-toggle="buttons">
                                                    <label class="btn btn-secondary active">
                                                        <input type="radio" name="image-hover-box-layouts"value="1"  checked="">1st
                                                    </label>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="modal-footer">
                                        <input type="hidden" id="oxistyledata" name="oxistyledata" value="">
                                        <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>
                                        <input type="submit" class="btn btn-success" name="addonsdatasubmit" id="addonsdatasubmit" value="Save">
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>');
    }

    public function template() {
        ?>
        <div class="oxi-addons-row">
            <?php
            $importbutton = false;
            foreach ($this->TEMPLATE as $key => $value) {
                $id = explode('-', $key)[1];
                if (array_key_exists($key, $this->activated_template)):
                    ?>
                    <div class="oxi-addons-col-1" id="<?php echo $key; ?>">
                        <div class="oxi-addons-style-preview">
                            <div class="oxi-addons-style-preview-top oxi-addons-center">
                                <?php
                                $i = 1;
                                foreach ($value['files'] as $v) {
                                    $style = json_decode($v, true);
                                    $s = explode('-', $style['style']['style_name']);
                                    echo '<div class="oxi-bt-col-lg-12 oxi-bt-col-md-12 oxi-bt-col-sm-12">';
                                    $CLASS = 'OXI_IMAGE_HOVER_PLUGINS\Modules\\' . ucfirst($s[0]) . '\Render\Effects' . $s[1];
                                    if (class_exists($CLASS)):
                                        new $CLASS($style['style'], $style['child']);
                                    endif;
                                    echo '<textarea style="display:none" id="oxistyle' . $id . 'data-' . $i . '">' . htmlentities(json_encode($style)) . '</textarea>';
                                    echo '</div>';
                                    $i++;
                                }
                                ?>
                            </div>
                            <div class="oxi-addons-style-preview-bottom">
                                <div class="oxi-addons-style-preview-bottom-left">
                                    <?php echo $value['name']; ?>
                                </div>
                                <div class="oxi-addons-style-preview-bottom-right">
                                    <button class="btn btn-warning oxi-addons-addons-style-btn-warning" title="Delete" data-value="<?php echo $id; ?>" data-effects="<?php echo $this->effects; ?>" type="button" value="Deactive" name="styledelete<?php echo $id; ?>">Deactive</button>  
                                    <button type="button" class="btn btn-success oxi-addons-addons-template-create" effects-data="oxistyle<?php echo $id; ?>data">Create Style</button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <?php
                else:
                    $importbutton = true;
                endif;
            }

            if ($importbutton):
                ?>
                <div class="oxi-addons-col-1 oxi-import">
                    <div class="oxi-addons-style-preview">
                        <div class="oxilab-admin-style-preview-top">
                            <a href="<?php echo admin_url("admin.php?page=oxi-image-hover-ultimate&effects=$this->effects&import=templates"); ?>">
                                <div class="oxilab-admin-add-new-item">
                                    <span>
                                        <i class="fas fa-plus-circle oxi-icons"></i>  
                                        Add More Templates
                                    </span>
                                </div>
                            </a>
                        </div>
                    </div>
                </div>
                <?php
            endif;
            ?>


        </div>
        <?php
    }

    public function import_template() {
        ?>
        <div class="oxi-addons-row">
            <?php
            foreach ($this->TEMPLATE as $key => $value) {
                $id = explode('-', $key)[1];
                if (!array_key_exists($key, $this->activated_template)):
                    ?>
                    <div class="oxi-addons-col-1" id="<?php echo $key; ?>">
                        <div class="oxi-addons-style-preview">
                            <div class="oxi-addons-style-preview-top oxi-addons-center">
                                <?php
                                $i = 1;
                                foreach ($value['files'] as $v) {
                                    $style = json_decode($v, true);
                                    $s = explode('-', $style['style']['style_name']);
                                    echo '<div class="oxi-bt-col-lg-12 oxi-bt-col-md-12 oxi-bt-col-sm-12">';
                                    $CLASS = 'OXI_IMAGE_HOVER_PLUGINS\Modules\\' . ucfirst($s[0]) . '\Render\Effects' . $s[1];
                                    if (class_exists($CLASS)):
                                        new $CLASS($style['style'], $style['child']);
                                    endif;
                                    echo '</div>';
                                    $i++;
                                }
                                ?>
                            </div>
                            <div class="oxi-addons-style-preview-bottom">
                                <div class="oxi-addons-style-preview-bottom-left">
                                    <?php echo $value['name']; ?>
                                </div>
                                <div class="oxi-addons-style-preview-bottom-right">
                                    <?php
                                      if (apply_filters('oxi-image-hover-plugin-version', false) == true || array_key_exists($key, $this->pre_clecked)):
                                        ?>
                                        <button class="btn btn-success oxi-addons-addons-style-btn-active" title="Active Templates" data-value="<?php echo $id; ?>" data-effects="<?php echo $this->effects; ?>" type="button" value="Active" name="styleactive<?php echo $id; ?>">Active Templates</button>  
                                        <?php
                                    else:
                                        ?>
                                        <button class="btn btn-danger" title="Premium Templates"  type="button" value="Premium Templates" name="styleactive<?php echo $id; ?>">Premium Templates</button>  
                                    <?php
                                    endif;
                                    ?>
                                </div>
                            </div>
                        </div>
                    </div>
                    <?php
                endif;
            }
            ?>
        </div>
        <?php
    }

    public function JSON_DATA() {
        $this->TEMPLATE = [
            'carousel-1' => [
                'name' => 'Slick Carousel',
                'files' => [
                    '{"plugin":"image-hover","style":{"id":"69","type":"","name":"Style 1","style_name":"carousel-1","rawdata":"{\"carousel_register_style\":\"\",\"carousel_item_slide-lap-size\":\"1\",\"carousel_item_slide-tab-size\":\"1\",\"carousel_item_slide-mob-size\":\"1\",\"carousel_autoplay\":\"yes\",\"carousel_autoplay_speed\":\"2000\",\"carousel_speed\":\"1000\",\"carousel_pause_on_hover\":\"yes\",\"carousel_infinite\":\"yes\",\"carousel_adaptive_height\":\"yes\",\"carousel_show_arrows\":\"yes\",\"carousel_show_dots\":\"yes\",\"carousel_left_arrow\":\"fas fa-chevron-left\",\"carousel_right_arrow\":\"fas fa-chevron-right\",\"carousel_arrows_size-lap-choices\":\"px\",\"carousel_arrows_size-lap-size\":\"20\",\"carousel_arrows_size-tab-choices\":\"px\",\"carousel_arrows_size-tab-size\":\"\",\"carousel_arrows_size-mob-choices\":\"px\",\"carousel_arrows_size-mob-size\":\"\",\"carousel_arrows_position_x-lap-choices\":\"px\",\"carousel_arrows_position_x-lap-size\":\"20\",\"carousel_arrows_position_x-tab-choices\":\"px\",\"carousel_arrows_position_x-tab-size\":\"\",\"carousel_arrows_position_x-mob-choices\":\"px\",\"carousel_arrows_position_x-mob-size\":\"\",\"carousel_arrows_position_y-lap-choices\":\"%\",\"carousel_arrows_position_y-lap-size\":\"50\",\"carousel_arrows_position_y-tab-choices\":\"%\",\"carousel_arrows_position_y-tab-size\":\"\",\"carousel_arrows_position_y-mob-choices\":\"%\",\"carousel_arrows_position_y-mob-size\":\"\",\"carousel_arrows_color\":\"#ffffff\",\"carousel_arrows_background\":\"rgba(171, 0, 201, 1)\",\"carousel_arrows_border-type\":\"\",\"carousel_arrows_border-width-lap-choices\":\"px\",\"carousel_arrows_border-width-lap-top\":\"\",\"carousel_arrows_border-width-lap-right\":\"\",\"carousel_arrows_border-width-lap-bottom\":\"\",\"carousel_arrows_border-width-lap-left\":\"\",\"carousel_arrows_border-width-tab-choices\":\"px\",\"carousel_arrows_border-width-tab-top\":\"\",\"carousel_arrows_border-width-tab-right\":\"\",\"carousel_arrows_border-width-tab-bottom\":\"\",\"carousel_arrows_border-width-tab-left\":\"\",\"carousel_arrows_border-width-mob-choices\":\"px\",\"carousel_arrows_border-width-mob-top\":\"\",\"carousel_arrows_border-width-mob-right\":\"\",\"carousel_arrows_border-width-mob-bottom\":\"\",\"carousel_arrows_border-width-mob-left\":\"\",\"carousel_arrows_border-color\":\"\",\"carousel_arrows_shadow-shadow\":\"yes\",\"carousel_arrows_shadow-type\":\"\",\"carousel_arrows_shadow-horizontal-size\":\"0\",\"carousel_arrows_shadow-vertical-size\":\"0\",\"carousel_arrows_shadow-blur-size\":\"0\",\"carousel_arrows_shadow-spread-size\":\"0\",\"carousel_arrows_shadow-color\":\"#cccccc\",\"carousel_arrows_color_hover\":\"#ffffff\",\"carousel_arrows_background_hover\":\"rgba(142,5,163,1.00)\",\"carousel_arrows_border_hover-type\":\"\",\"carousel_arrows_border_hover-width-lap-choices\":\"px\",\"carousel_arrows_border_hover-width-lap-top\":\"\",\"carousel_arrows_border_hover-width-lap-right\":\"\",\"carousel_arrows_border_hover-width-lap-bottom\":\"\",\"carousel_arrows_border_hover-width-lap-left\":\"\",\"carousel_arrows_border_hover-width-tab-choices\":\"px\",\"carousel_arrows_border_hover-width-tab-top\":\"\",\"carousel_arrows_border_hover-width-tab-right\":\"\",\"carousel_arrows_border_hover-width-tab-bottom\":\"\",\"carousel_arrows_border_hover-width-tab-left\":\"\",\"carousel_arrows_border_hover-width-mob-choices\":\"px\",\"carousel_arrows_border_hover-width-mob-top\":\"\",\"carousel_arrows_border_hover-width-mob-right\":\"\",\"carousel_arrows_border_hover-width-mob-bottom\":\"\",\"carousel_arrows_border_hover-width-mob-left\":\"\",\"carousel_arrows_border_hover-color\":\"\",\"carousel_arrows_shadow_hover-shadow\":\"yes\",\"carousel_arrows_shadow_hover-type\":\"\",\"carousel_arrows_shadow_hover-horizontal-size\":\"0\",\"carousel_arrows_shadow_hover-vertical-size\":\"0\",\"carousel_arrows_shadow_hover-blur-size\":\"0\",\"carousel_arrows_shadow_hover-spread-size\":\"0\",\"carousel_arrows_shadow_hover-color\":\"#cccccc\",\"carousel_arrows_radius-lap-choices\":\"px\",\"carousel_arrows_radius-lap-top\":\"20\",\"carousel_arrows_radius-lap-right\":\"20\",\"carousel_arrows_radius-lap-bottom\":\"20\",\"carousel_arrows_radius-lap-left\":\"20\",\"carousel_arrows_radius-tab-choices\":\"px\",\"carousel_arrows_radius-tab-top\":\"\",\"carousel_arrows_radius-tab-right\":\"\",\"carousel_arrows_radius-tab-bottom\":\"\",\"carousel_arrows_radius-tab-left\":\"\",\"carousel_arrows_radius-mob-choices\":\"px\",\"carousel_arrows_radius-mob-top\":\"\",\"carousel_arrows_radius-mob-right\":\"\",\"carousel_arrows_radius-mob-bottom\":\"\",\"carousel_arrows_radius-mob-left\":\"\",\"carousel_arrows_padding-lap-choices\":\"px\",\"carousel_arrows_padding-lap-top\":\"6\",\"carousel_arrows_padding-lap-right\":\"10\",\"carousel_arrows_padding-lap-bottom\":\"6\",\"carousel_arrows_padding-lap-left\":\"10\",\"carousel_arrows_padding-tab-choices\":\"px\",\"carousel_arrows_padding-tab-top\":\"\",\"carousel_arrows_padding-tab-right\":\"\",\"carousel_arrows_padding-tab-bottom\":\"\",\"carousel_arrows_padding-tab-left\":\"\",\"carousel_arrows_padding-mob-choices\":\"px\",\"carousel_arrows_padding-mob-top\":\"\",\"carousel_arrows_padding-mob-right\":\"\",\"carousel_arrows_padding-mob-bottom\":\"\",\"carousel_arrows_padding-mob-left\":\"\",\"carousel_dots_position_size-lap-choices\":\"px\",\"carousel_dots_position_size-lap-size\":\"20\",\"carousel_dots_position_size-tab-choices\":\"px\",\"carousel_dots_position_size-tab-size\":\"10\",\"carousel_dots_position_size-mob-choices\":\"px\",\"carousel_dots_position_size-mob-size\":\"10\",\"carousel_dots_width_height-lap-choices\":\"px\",\"carousel_dots_width_height-lap-size\":\"12\",\"carousel_dots_width_height-tab-choices\":\"px\",\"carousel_dots_width_height-tab-size\":\"20\",\"carousel_dots_width_height-mob-choices\":\"px\",\"carousel_dots_width_height-mob-size\":\"20\",\"carousel_dots_position_Y-lap-choices\":\"%\",\"carousel_dots_position_Y-lap-size\":\"-12\",\"carousel_dots_position_Y-tab-choices\":\"%\",\"carousel_dots_position_Y-tab-size\":\"35\",\"carousel_dots_position_Y-mob-choices\":\"%\",\"carousel_dots_position_Y-mob-size\":\"35\",\"carousel_dots_spacing-lap-choices\":\"px\",\"carousel_dots_spacing-lap-size\":\"3\",\"carousel_dots_spacing-tab-choices\":\"px\",\"carousel_dots_spacing-tab-size\":\"3\",\"carousel_dots_spacing-mob-choices\":\"px\",\"carousel_dots_spacing-mob-size\":\"3\",\"carousel_dots_color\":\"#ffffff\",\"carousel_dots_bg_color\":\"rgba(0, 0, 0, 1)\",\"carousel_dots_border-type\":\"\",\"carousel_dots_border-width-lap-choices\":\"px\",\"carousel_dots_border-width-lap-top\":\"\",\"carousel_dots_border-width-lap-right\":\"\",\"carousel_dots_border-width-lap-bottom\":\"\",\"carousel_dots_border-width-lap-left\":\"\",\"carousel_dots_border-width-tab-choices\":\"px\",\"carousel_dots_border-width-tab-top\":\"\",\"carousel_dots_border-width-tab-right\":\"\",\"carousel_dots_border-width-tab-bottom\":\"\",\"carousel_dots_border-width-tab-left\":\"\",\"carousel_dots_border-width-mob-choices\":\"px\",\"carousel_dots_border-width-mob-top\":\"\",\"carousel_dots_border-width-mob-right\":\"\",\"carousel_dots_border-width-mob-bottom\":\"\",\"carousel_dots_border-width-mob-left\":\"\",\"carousel_dots_border-color\":\"\",\"carousel_dots_color_hover\":\"rgba(255, 255, 255, 1)\",\"carousel_dots_bg_color_hover\":\"rgba(255, 0, 0, 1)\",\"carousel_dots_border_hover-type\":\"\",\"carousel_dots_border_hover-width-lap-choices\":\"px\",\"carousel_dots_border_hover-width-lap-top\":\"\",\"carousel_dots_border_hover-width-lap-right\":\"\",\"carousel_dots_border_hover-width-lap-bottom\":\"\",\"carousel_dots_border_hover-width-lap-left\":\"\",\"carousel_dots_border_hover-width-tab-choices\":\"px\",\"carousel_dots_border_hover-width-tab-top\":\"\",\"carousel_dots_border_hover-width-tab-right\":\"\",\"carousel_dots_border_hover-width-tab-bottom\":\"\",\"carousel_dots_border_hover-width-tab-left\":\"\",\"carousel_dots_border_hover-width-mob-choices\":\"px\",\"carousel_dots_border_hover-width-mob-top\":\"\",\"carousel_dots_border_hover-width-mob-right\":\"\",\"carousel_dots_border_hover-width-mob-bottom\":\"\",\"carousel_dots_border_hover-width-mob-left\":\"\",\"carousel_dots_border_hover-color\":\"\",\"carousel_dots_color_active\":\"#ffffff\",\"carousel_dots_bg_color_active\":\"#ab00c9\",\"carousel_dots_border_active-type\":\"\",\"carousel_dots_border_active-width-lap-choices\":\"px\",\"carousel_dots_border_active-width-lap-top\":\"\",\"carousel_dots_border_active-width-lap-right\":\"\",\"carousel_dots_border_active-width-lap-bottom\":\"\",\"carousel_dots_border_active-width-lap-left\":\"\",\"carousel_dots_border_active-width-tab-choices\":\"px\",\"carousel_dots_border_active-width-tab-top\":\"\",\"carousel_dots_border_active-width-tab-right\":\"\",\"carousel_dots_border_active-width-tab-bottom\":\"\",\"carousel_dots_border_active-width-tab-left\":\"\",\"carousel_dots_border_active-width-mob-choices\":\"px\",\"carousel_dots_border_active-width-mob-top\":\"\",\"carousel_dots_border_active-width-mob-right\":\"\",\"carousel_dots_border_active-width-mob-bottom\":\"\",\"carousel_dots_border_active-width-mob-left\":\"\",\"carousel_dots_border_active-color\":\"\",\"carousel_dots_border_radius_normal-lap-choices\":\"px\",\"carousel_dots_border_radius_normal-lap-top\":\"10\",\"carousel_dots_border_radius_normal-lap-right\":\"10\",\"carousel_dots_border_radius_normal-lap-bottom\":\"10\",\"carousel_dots_border_radius_normal-lap-left\":\"10\",\"carousel_dots_border_radius_normal-tab-choices\":\"px\",\"carousel_dots_border_radius_normal-tab-top\":\"\",\"carousel_dots_border_radius_normal-tab-right\":\"\",\"carousel_dots_border_radius_normal-tab-bottom\":\"\",\"carousel_dots_border_radius_normal-tab-left\":\"\",\"carousel_dots_border_radius_normal-mob-choices\":\"px\",\"carousel_dots_border_radius_normal-mob-top\":\"\",\"carousel_dots_border_radius_normal-mob-right\":\"\",\"carousel_dots_border_radius_normal-mob-bottom\":\"\",\"carousel_dots_border_radius_normal-mob-left\":\"\",\"image-hover-custom-css\":\"\",\"image-hover-preview-color\":\"#FFF\",\"image-hover-style-id\":\"69\",\"image-hover-template\":\"Carousel-1\",\"carousel_center_mode\":\"0\"}","stylesheet":".oxi-image-hover-wrapper-69 .oxi_carousel_arrows .oxi-icons{font-size:20px; line-height:20px;color: #ffffff;background: rgba(171, 0, 201, 1);border-radius:20px 20px 20px 20px;padding:6px 10px 6px 10px;}.oxi-image-hover-wrapper-69 .oxi_carousel_arrows.oxi_carousel_prev{left:20px; right:auto;}.oxi-image-hover-wrapper-69 .oxi_carousel_arrows.oxi_carousel_next{right:20px; left:auto}.oxi-image-hover-wrapper-69 .oxi_carousel_arrows{top:50%; transform: translateY(-50%);}.oxi-image-hover-wrapper-69 .oxi_carousel_arrows .oxi-icons:hover{color: #ffffff;background: rgba(142,5,163,1.00);}.oxi-image-hover-wrapper-69 .oxi_carousel_dots li button:before{font-size: 20px;line-height: 12px;color: #ffffff;background: rgba(0, 0, 0, 1);border-radius: 10px 10px 10px 10px;}.oxi-image-hover-wrapper-69 .oxi_carousel_dots li{width: 12px; height: 12px;margin: 3px;}.oxi-image-hover-wrapper-69 .oxi_carousel_dots{bottom: -12%;}.oxi-image-hover-wrapper-69 .oxi_carousel_dots li:hover button:before{color: rgba(255, 255, 255, 1);background: rgba(255, 0, 0, 1);}.oxi-image-hover-wrapper-69 .oxi_carousel_dots li.slick-active button:before{color: #ffffff;background: #ab00c9;}@media only screen and (min-width : 669px) and (max-width : 993px){.oxi-image-hover-wrapper-69 .oxi_carousel_arrows .oxi-icons{border-radius:px px px px;padding:px px px px;}.oxi-image-hover-wrapper-69 .oxi_carousel_dots li button:before{font-size: 10px;line-height: 20px;border-radius: px px px px;}.oxi-image-hover-wrapper-69 .oxi_carousel_dots li{width: 20px; height: 20px;margin: 3px;}.oxi-image-hover-wrapper-69 .oxi_carousel_dots{bottom: 35%;}}@media only screen and (max-width : 668px){.oxi-image-hover-wrapper-69 .oxi_carousel_arrows .oxi-icons{border-radius:px px px px;padding:px px px px;}.oxi-image-hover-wrapper-69 .oxi_carousel_dots li button:before{font-size: 10px;line-height: 20px;border-radius: px px px px;}.oxi-image-hover-wrapper-69 .oxi_carousel_dots li{width: 20px; height: 20px;margin: 3px;}.oxi-image-hover-wrapper-69 .oxi_carousel_dots{bottom: 35%;}}","font_family":"[]"},"child":[{"id":"91","styleid":"69","rawdata":"{\"oxi_image_comparison_image_one-select\":\"media-library\",\"oxi_image_comparison_image_one-image\":\"https:\\\/\\\/www.image-hover.oxilab.org\\\/wp-content\\\/uploads\\\/2020\\\/02\\\/pexels-photo-210019.png\",\"oxi_image_comparison_image_one-image-alt\":\"\",\"oxi_image_comparison_image_one-url\":\"https:\\\/\\\/www.shortcode-addons.com\\\/wp-content\\\/uploads\\\/2020\\\/01\\\/placeholder.png\",\"oxi_image_comparison_image_two-select\":\"media-library\",\"oxi_image_comparison_image_two-image\":\"https:\\\/\\\/www.image-hover.oxilab.org\\\/wp-content\\\/uploads\\\/2020\\\/02\\\/pexels-photo-210019-1.png\",\"oxi_image_comparison_image_two-image-alt\":\"\",\"oxi_image_comparison_image_two-url\":\"https:\\\/\\\/www.shortcode-addons.com\\\/wp-content\\\/uploads\\\/2020\\\/01\\\/placeholder.png\",\"oxi_image_comparison_body_offset-size\":\"0.5\",\"oxi_image_comparison_click\":\"false\",\"oxi_image_comparison_position\":\"true\",\"oxi_image_comparison_hover\":\"false\",\"shortcodeitemid\":\"19\"}"}]}',
                ],
            ],
            'carousel-2' => [
                'name' => 'Flipster Carousel',
                'files' => [
                    '{"plugin":"image-hover","style":{"id":"73","type":"","name":"","style_name":"carousel-2","rawdata":"{\"carousel_register_style\":\"\",\"carousel_effect\":\"coverflow\",\"carousel_autoplay_speed\":\"2000\",\"carousel_fadeIn\":\"500\",\"carousel_center_mode\":\"yes\",\"carousel_start_number\":\"2\",\"carousel_pause_on_hover\":\"yes\",\"carousel_infinite\":\"yes\",\"carousel_click\":\"yes\",\"carousel_touch\":\"yes\",\"carousel_show_arrows\":\"yes\",\"carousel_left_arrow\":\"fas fa-chevron-left\",\"carousel_right_arrow\":\"fas fa-chevron-right\",\"carousel_arrows_size-lap-choices\":\"px\",\"carousel_arrows_size-lap-size\":\"20\",\"carousel_arrows_size-tab-choices\":\"px\",\"carousel_arrows_size-tab-size\":\"20\",\"carousel_arrows_size-mob-choices\":\"px\",\"carousel_arrows_size-mob-size\":\"20\",\"carousel_arrows_position_x-lap-choices\":\"px\",\"carousel_arrows_position_x-lap-size\":\"25\",\"carousel_arrows_position_x-tab-choices\":\"px\",\"carousel_arrows_position_x-tab-size\":\"25\",\"carousel_arrows_position_x-mob-choices\":\"px\",\"carousel_arrows_position_x-mob-size\":\"25\",\"carousel_arrows_position_y-lap-choices\":\"%\",\"carousel_arrows_position_y-lap-size\":\"50\",\"carousel_arrows_position_y-tab-choices\":\"%\",\"carousel_arrows_position_y-tab-size\":\"50\",\"carousel_arrows_position_y-mob-choices\":\"%\",\"carousel_arrows_position_y-mob-size\":\"50\",\"carousel_arrows_color\":\"#ffffff\",\"carousel_arrows_background\":\"rgba(171, 0, 201, 1)\",\"carousel_arrows_border-type\":\"\",\"carousel_arrows_border-width-lap-choices\":\"px\",\"carousel_arrows_border-width-lap-top\":\"\",\"carousel_arrows_border-width-lap-right\":\"\",\"carousel_arrows_border-width-lap-bottom\":\"\",\"carousel_arrows_border-width-lap-left\":\"\",\"carousel_arrows_border-width-tab-choices\":\"px\",\"carousel_arrows_border-width-tab-top\":\"\",\"carousel_arrows_border-width-tab-right\":\"\",\"carousel_arrows_border-width-tab-bottom\":\"\",\"carousel_arrows_border-width-tab-left\":\"\",\"carousel_arrows_border-width-mob-choices\":\"px\",\"carousel_arrows_border-width-mob-top\":\"\",\"carousel_arrows_border-width-mob-right\":\"\",\"carousel_arrows_border-width-mob-bottom\":\"\",\"carousel_arrows_border-width-mob-left\":\"\",\"carousel_arrows_border-color\":\"\",\"carousel_arrows_shadow-shadow\":\"yes\",\"carousel_arrows_shadow-type\":\"\",\"carousel_arrows_shadow-horizontal-size\":\"0\",\"carousel_arrows_shadow-vertical-size\":\"0\",\"carousel_arrows_shadow-blur-size\":\"0\",\"carousel_arrows_shadow-spread-size\":\"0\",\"carousel_arrows_shadow-color\":\"#cccccc\",\"carousel_arrows_color_hover\":\"#ffffff\",\"carousel_arrows_background_hover\":\"rgba(171, 0, 201, 1)\",\"carousel_arrows_border_hover-type\":\"\",\"carousel_arrows_border_hover-width-lap-choices\":\"px\",\"carousel_arrows_border_hover-width-lap-top\":\"\",\"carousel_arrows_border_hover-width-lap-right\":\"\",\"carousel_arrows_border_hover-width-lap-bottom\":\"\",\"carousel_arrows_border_hover-width-lap-left\":\"\",\"carousel_arrows_border_hover-width-tab-choices\":\"px\",\"carousel_arrows_border_hover-width-tab-top\":\"\",\"carousel_arrows_border_hover-width-tab-right\":\"\",\"carousel_arrows_border_hover-width-tab-bottom\":\"\",\"carousel_arrows_border_hover-width-tab-left\":\"\",\"carousel_arrows_border_hover-width-mob-choices\":\"px\",\"carousel_arrows_border_hover-width-mob-top\":\"\",\"carousel_arrows_border_hover-width-mob-right\":\"\",\"carousel_arrows_border_hover-width-mob-bottom\":\"\",\"carousel_arrows_border_hover-width-mob-left\":\"\",\"carousel_arrows_border_hover-color\":\"\",\"carousel_arrows_shadow_hover-shadow\":\"yes\",\"carousel_arrows_shadow_hover-type\":\"\",\"carousel_arrows_shadow_hover-horizontal-size\":\"0\",\"carousel_arrows_shadow_hover-vertical-size\":\"0\",\"carousel_arrows_shadow_hover-blur-size\":\"0\",\"carousel_arrows_shadow_hover-spread-size\":\"0\",\"carousel_arrows_shadow_hover-color\":\"#cccccc\",\"carousel_arrows_radius-lap-choices\":\"px\",\"carousel_arrows_radius-lap-top\":\"\",\"carousel_arrows_radius-lap-right\":\"\",\"carousel_arrows_radius-lap-bottom\":\"\",\"carousel_arrows_radius-lap-left\":\"\",\"carousel_arrows_radius-tab-choices\":\"px\",\"carousel_arrows_radius-tab-top\":\"\",\"carousel_arrows_radius-tab-right\":\"\",\"carousel_arrows_radius-tab-bottom\":\"\",\"carousel_arrows_radius-tab-left\":\"\",\"carousel_arrows_radius-mob-choices\":\"px\",\"carousel_arrows_radius-mob-top\":\"\",\"carousel_arrows_radius-mob-right\":\"\",\"carousel_arrows_radius-mob-bottom\":\"\",\"carousel_arrows_radius-mob-left\":\"\",\"carousel_arrows_padding-lap-choices\":\"px\",\"carousel_arrows_padding-lap-top\":\"10\",\"carousel_arrows_padding-lap-right\":\"10\",\"carousel_arrows_padding-lap-bottom\":\"10\",\"carousel_arrows_padding-lap-left\":\"10\",\"carousel_arrows_padding-tab-choices\":\"px\",\"carousel_arrows_padding-tab-top\":\"10\",\"carousel_arrows_padding-tab-right\":\"10\",\"carousel_arrows_padding-tab-bottom\":\"10\",\"carousel_arrows_padding-tab-left\":\"10\",\"carousel_arrows_padding-mob-choices\":\"px\",\"carousel_arrows_padding-mob-top\":\"10\",\"carousel_arrows_padding-mob-right\":\"10\",\"carousel_arrows_padding-mob-bottom\":\"10\",\"carousel_arrows_padding-mob-left\":\"10\",\"image-hover-custom-css\":\"\",\"image-hover-preview-color\":\"#FFF\",\"image-hover-style-id\":\"73\",\"image-hover-template\":\"Carousel-2\",\"carousel_autoplay\":\"0\"}","stylesheet":".oxi-image-hover-wrapper-73 .oxi_carousel_arrows .oxi-icons{font-size:20px; line-height:20px;color: #ffffff;background: rgba(171, 0, 201, 1);border-radius:px px px px;padding:10px 10px 10px 10px;}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows.oxi_carousel_prev{left:25px; right:auto;}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows.oxi_carousel_next{right:25px; left:auto}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows{top:50%; transform: translateY(-50%);}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows .oxi-icons:hover{color: #ffffff;background: rgba(171, 0, 201, 1);}@media only screen and (min-width : 669px) and (max-width : 993px){.oxi-image-hover-wrapper-73 .oxi_carousel_arrows .oxi-icons{font-size:20px; line-height:20px;border-radius:px px px px;padding:10px 10px 10px 10px;}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows.oxi_carousel_prev{left:25px; right:auto;}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows.oxi_carousel_next{right:25px; left:auto}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows{top:50%; transform: translateY(-50%);}}@media only screen and (max-width : 668px){.oxi-image-hover-wrapper-73 .oxi_carousel_arrows .oxi-icons{font-size:20px; line-height:20px;border-radius:px px px px;padding:10px 10px 10px 10px;}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows.oxi_carousel_prev{left:25px; right:auto;}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows.oxi_carousel_next{right:25px; left:auto}.oxi-image-hover-wrapper-73 .oxi_carousel_arrows{top:50%; transform: translateY(-50%);}}","font_family":"[]"},"child":[{"id":"109","styleid":"73","rawdata":"{\"oxi_image_comparison_image_one-select\":\"media-library\",\"oxi_image_comparison_image_one-image\":\"https:\\\/\\\/www.image-hover.oxilab.org\\\/wp-content\\\/uploads\\\/2020\\\/02\\\/pexels-photo-210019-2.png\",\"oxi_image_comparison_image_one-image-alt\":\"\",\"oxi_image_comparison_image_one-url\":\"https:\\\/\\\/www.shortcode-addons.com\\\/wp-content\\\/uploads\\\/2020\\\/01\\\/placeholder.png\",\"oxi_image_comparison_image_two-select\":\"media-library\",\"oxi_image_comparison_image_two-image\":\"https:\\\/\\\/www.image-hover.oxilab.org\\\/wp-content\\\/uploads\\\/2020\\\/02\\\/pexels-photo-210019-3.png\",\"oxi_image_comparison_image_two-image-alt\":\"\",\"oxi_image_comparison_image_two-url\":\"https:\\\/\\\/www.shortcode-addons.com\\\/wp-content\\\/uploads\\\/2020\\\/01\\\/placeholder.png\",\"oxi_image_comparison_body_offset-size\":\"0.5\",\"oxi_image_comparison_click\":\"false\",\"oxi_image_comparison_position\":\"false \",\"oxi_image_comparison_hover\":\"true\",\"shortcodeitemid\":\"21\"}"}]}',
                ],
            ],
            'carousel-3' => [
                'name' => 'Swiper Carousel',
                'files' => [
                    '{"plugin":"image-hover","style":{"id":"74","type":"","name":"Style 3","style_name":"carousel-3","rawdata":"{\"carousel_register_style\":\"\",\"carousel_width-lap-choices\":\"%\",\"carousel_width-lap-size\":\"70\",\"carousel_width-tab-choices\":\"%\",\"carousel_width-tab-size\":\"80\",\"carousel_width-mob-choices\":\"%\",\"carousel_width-mob-size\":\"80\",\"carousel_item-lap-size\":\"3\",\"carousel_item-tab-size\":\"2\",\"carousel_item-mob-size\":\"1\",\"carousel_grap-lap-size\":\"10\",\"carousel_grap-tab-size\":\"10\",\"carousel_grap-mob-size\":\"10\",\"carousel_effect\":\"slide\",\"carousel_autoplay\":\"yes\",\"carousel_autoplay_speed\":\"2000\",\"carousel_speed\":\"500\",\"carousel_pause_on_hover\":\"yes\",\"carousel_infinite\":\"yes\",\"carousel_adaptive_height\":\"yes\",\"carousel_direction\":\"ltr\",\"carousel_show_arrows\":\"yes\",\"carousel_left_arrow\":\"fas fa-chevron-left\",\"carousel_right_arrow\":\"fas fa-chevron-right\",\"carousel_arrows_size-lap-choices\":\"px\",\"carousel_arrows_size-lap-size\":\"20\",\"carousel_arrows_size-tab-choices\":\"px\",\"carousel_arrows_size-tab-size\":\"20\",\"carousel_arrows_size-mob-choices\":\"px\",\"carousel_arrows_size-mob-size\":\"20\",\"carousel_arrows_position_x-lap-choices\":\"px\",\"carousel_arrows_position_x-lap-size\":\"25\",\"carousel_arrows_position_x-tab-choices\":\"px\",\"carousel_arrows_position_x-tab-size\":\"25\",\"carousel_arrows_position_x-mob-choices\":\"px\",\"carousel_arrows_position_x-mob-size\":\"25\",\"carousel_arrows_position_y-lap-choices\":\"%\",\"carousel_arrows_position_y-lap-size\":\"59\",\"carousel_arrows_position_y-tab-choices\":\"%\",\"carousel_arrows_position_y-tab-size\":\"50\",\"carousel_arrows_position_y-mob-choices\":\"%\",\"carousel_arrows_position_y-mob-size\":\"50\",\"carousel_arrows_color\":\"#ffffff\",\"carousel_arrows_background\":\"rgba(171, 0, 201, 1)\",\"carousel_arrows_border-type\":\"\",\"carousel_arrows_border-width-lap-choices\":\"px\",\"carousel_arrows_border-width-lap-top\":\"\",\"carousel_arrows_border-width-lap-right\":\"\",\"carousel_arrows_border-width-lap-bottom\":\"\",\"carousel_arrows_border-width-lap-left\":\"\",\"carousel_arrows_border-width-tab-choices\":\"px\",\"carousel_arrows_border-width-tab-top\":\"\",\"carousel_arrows_border-width-tab-right\":\"\",\"carousel_arrows_border-width-tab-bottom\":\"\",\"carousel_arrows_border-width-tab-left\":\"\",\"carousel_arrows_border-width-mob-choices\":\"px\",\"carousel_arrows_border-width-mob-top\":\"\",\"carousel_arrows_border-width-mob-right\":\"\",\"carousel_arrows_border-width-mob-bottom\":\"\",\"carousel_arrows_border-width-mob-left\":\"\",\"carousel_arrows_border-color\":\"\",\"carousel_arrows_shadow-shadow\":\"yes\",\"carousel_arrows_shadow-type\":\"\",\"carousel_arrows_shadow-horizontal-size\":\"0\",\"carousel_arrows_shadow-vertical-size\":\"0\",\"carousel_arrows_shadow-blur-size\":\"0\",\"carousel_arrows_shadow-spread-size\":\"0\",\"carousel_arrows_shadow-color\":\"#cccccc\",\"carousel_arrows_color_hover\":\"#ffffff\",\"carousel_arrows_background_hover\":\"rgba(171, 0, 201, 1)\",\"carousel_arrows_border_hover-type\":\"\",\"carousel_arrows_border_hover-width-lap-choices\":\"px\",\"carousel_arrows_border_hover-width-lap-top\":\"\",\"carousel_arrows_border_hover-width-lap-right\":\"\",\"carousel_arrows_border_hover-width-lap-bottom\":\"\",\"carousel_arrows_border_hover-width-lap-left\":\"\",\"carousel_arrows_border_hover-width-tab-choices\":\"px\",\"carousel_arrows_border_hover-width-tab-top\":\"\",\"carousel_arrows_border_hover-width-tab-right\":\"\",\"carousel_arrows_border_hover-width-tab-bottom\":\"\",\"carousel_arrows_border_hover-width-tab-left\":\"\",\"carousel_arrows_border_hover-width-mob-choices\":\"px\",\"carousel_arrows_border_hover-width-mob-top\":\"\",\"carousel_arrows_border_hover-width-mob-right\":\"\",\"carousel_arrows_border_hover-width-mob-bottom\":\"\",\"carousel_arrows_border_hover-width-mob-left\":\"\",\"carousel_arrows_border_hover-color\":\"\",\"carousel_arrows_shadow_hover-shadow\":\"yes\",\"carousel_arrows_shadow_hover-type\":\"\",\"carousel_arrows_shadow_hover-horizontal-size\":\"0\",\"carousel_arrows_shadow_hover-vertical-size\":\"0\",\"carousel_arrows_shadow_hover-blur-size\":\"0\",\"carousel_arrows_shadow_hover-spread-size\":\"0\",\"carousel_arrows_shadow_hover-color\":\"#cccccc\",\"carousel_arrows_radius-lap-choices\":\"px\",\"carousel_arrows_radius-lap-top\":\"\",\"carousel_arrows_radius-lap-right\":\"\",\"carousel_arrows_radius-lap-bottom\":\"\",\"carousel_arrows_radius-lap-left\":\"\",\"carousel_arrows_radius-tab-choices\":\"px\",\"carousel_arrows_radius-tab-top\":\"\",\"carousel_arrows_radius-tab-right\":\"\",\"carousel_arrows_radius-tab-bottom\":\"\",\"carousel_arrows_radius-tab-left\":\"\",\"carousel_arrows_radius-mob-choices\":\"px\",\"carousel_arrows_radius-mob-top\":\"\",\"carousel_arrows_radius-mob-right\":\"\",\"carousel_arrows_radius-mob-bottom\":\"\",\"carousel_arrows_radius-mob-left\":\"\",\"carousel_arrows_padding-lap-choices\":\"px\",\"carousel_arrows_padding-lap-top\":\"10\",\"carousel_arrows_padding-lap-right\":\"10\",\"carousel_arrows_padding-lap-bottom\":\"10\",\"carousel_arrows_padding-lap-left\":\"10\",\"carousel_arrows_padding-tab-choices\":\"px\",\"carousel_arrows_padding-tab-top\":\"10\",\"carousel_arrows_padding-tab-right\":\"10\",\"carousel_arrows_padding-tab-bottom\":\"10\",\"carousel_arrows_padding-tab-left\":\"10\",\"carousel_arrows_padding-mob-choices\":\"px\",\"carousel_arrows_padding-mob-top\":\"10\",\"carousel_arrows_padding-mob-right\":\"10\",\"carousel_arrows_padding-mob-bottom\":\"10\",\"carousel_arrows_padding-mob-left\":\"10\",\"carousel_dots_width_height-lap-choices\":\"px\",\"carousel_dots_width_height-lap-size\":\"12\",\"carousel_dots_width_height-tab-choices\":\"px\",\"carousel_dots_width_height-tab-size\":\"12\",\"carousel_dots_width_height-mob-choices\":\"px\",\"carousel_dots_width_height-mob-size\":\"12\",\"carousel_dots_position_Y-lap-choices\":\"%\",\"carousel_dots_position_Y-lap-size\":\"0\",\"carousel_dots_position_Y-tab-choices\":\"%\",\"carousel_dots_position_Y-tab-size\":\"25\",\"carousel_dots_position_Y-mob-choices\":\"%\",\"carousel_dots_position_Y-mob-size\":\"25\",\"carousel_dots_spacing-lap-choices\":\"px\",\"carousel_dots_spacing-lap-size\":\"3\",\"carousel_dots_spacing-tab-choices\":\"px\",\"carousel_dots_spacing-tab-size\":\"3\",\"carousel_dots_spacing-mob-choices\":\"px\",\"carousel_dots_spacing-mob-size\":\"3\",\"carousel_dots_bg_color\":\"rgb(0, 0, 0)\",\"carousel_dots_border-type\":\"\",\"carousel_dots_border-width-lap-choices\":\"px\",\"carousel_dots_border-width-lap-top\":\"\",\"carousel_dots_border-width-lap-right\":\"\",\"carousel_dots_border-width-lap-bottom\":\"\",\"carousel_dots_border-width-lap-left\":\"\",\"carousel_dots_border-width-tab-choices\":\"px\",\"carousel_dots_border-width-tab-top\":\"\",\"carousel_dots_border-width-tab-right\":\"\",\"carousel_dots_border-width-tab-bottom\":\"\",\"carousel_dots_border-width-tab-left\":\"\",\"carousel_dots_border-width-mob-choices\":\"px\",\"carousel_dots_border-width-mob-top\":\"\",\"carousel_dots_border-width-mob-right\":\"\",\"carousel_dots_border-width-mob-bottom\":\"\",\"carousel_dots_border-width-mob-left\":\"\",\"carousel_dots_border-color\":\"\",\"carousel_dots_bg_color_hover\":\"rgb(119, 119, 119)\",\"carousel_dots_border_hover-type\":\"\",\"carousel_dots_border_hover-width-lap-choices\":\"px\",\"carousel_dots_border_hover-width-lap-top\":\"\",\"carousel_dots_border_hover-width-lap-right\":\"\",\"carousel_dots_border_hover-width-lap-bottom\":\"\",\"carousel_dots_border_hover-width-lap-left\":\"\",\"carousel_dots_border_hover-width-tab-choices\":\"px\",\"carousel_dots_border_hover-width-tab-top\":\"\",\"carousel_dots_border_hover-width-tab-right\":\"\",\"carousel_dots_border_hover-width-tab-bottom\":\"\",\"carousel_dots_border_hover-width-tab-left\":\"\",\"carousel_dots_border_hover-width-mob-choices\":\"px\",\"carousel_dots_border_hover-width-mob-top\":\"\",\"carousel_dots_border_hover-width-mob-right\":\"\",\"carousel_dots_border_hover-width-mob-bottom\":\"\",\"carousel_dots_border_hover-width-mob-left\":\"\",\"carousel_dots_border_hover-color\":\"\",\"carousel_dots_bg_color_active\":\"#ab00c9\",\"carousel_dots_border_active-type\":\"\",\"carousel_dots_border_active-width-lap-choices\":\"px\",\"carousel_dots_border_active-width-lap-top\":\"\",\"carousel_dots_border_active-width-lap-right\":\"\",\"carousel_dots_border_active-width-lap-bottom\":\"\",\"carousel_dots_border_active-width-lap-left\":\"\",\"carousel_dots_border_active-width-tab-choices\":\"px\",\"carousel_dots_border_active-width-tab-top\":\"\",\"carousel_dots_border_active-width-tab-right\":\"\",\"carousel_dots_border_active-width-tab-bottom\":\"\",\"carousel_dots_border_active-width-tab-left\":\"\",\"carousel_dots_border_active-width-mob-choices\":\"px\",\"carousel_dots_border_active-width-mob-top\":\"\",\"carousel_dots_border_active-width-mob-right\":\"\",\"carousel_dots_border_active-width-mob-bottom\":\"\",\"carousel_dots_border_active-width-mob-left\":\"\",\"carousel_dots_border_active-color\":\"\",\"carousel_dots_border_radius_normal-lap-choices\":\"px\",\"carousel_dots_border_radius_normal-lap-top\":\"\",\"carousel_dots_border_radius_normal-lap-right\":\"\",\"carousel_dots_border_radius_normal-lap-bottom\":\"\",\"carousel_dots_border_radius_normal-lap-left\":\"\",\"carousel_dots_border_radius_normal-tab-choices\":\"px\",\"carousel_dots_border_radius_normal-tab-top\":\"\",\"carousel_dots_border_radius_normal-tab-right\":\"\",\"carousel_dots_border_radius_normal-tab-bottom\":\"\",\"carousel_dots_border_radius_normal-tab-left\":\"\",\"carousel_dots_border_radius_normal-mob-choices\":\"px\",\"carousel_dots_border_radius_normal-mob-top\":\"\",\"carousel_dots_border_radius_normal-mob-right\":\"\",\"carousel_dots_border_radius_normal-mob-bottom\":\"\",\"carousel_dots_border_radius_normal-mob-left\":\"\",\"image-hover-custom-css\":\"\",\"image-hover-preview-color\":\"#FFF\",\"image-hover-style-id\":\"74\",\"image-hover-template\":\"Carousel-3\",\"carousel_grab_cursor\":\"0\",\"carousel_show_dots\":\"0\"}","stylesheet":".oxi-image-hover-wrapper-74.oxi-addons-container .oxi-addons-row.oxi-addons-swiper-wrapper{width: 70%;}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows .oxi-icons{font-size:20px; line-height:20px;color: #ffffff;background: rgba(171, 0, 201, 1);border-radius:px px px px;padding:10px 10px 10px 10px;}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows.oxi_carousel_prev{left:25px; right:auto;}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows.oxi_carousel_next{right:25px; left:auto}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows{top:59%; transform: translateY(-59%);}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows .oxi-icons:hover{color: #ffffff;background: rgba(171, 0, 201, 1);}.oxi-image-hover-wrapper-74 .oxi_carousel_dots .swiper-pagination-bullet{width: 12px; height: 12px;margin: 3px;background: rgb(0, 0, 0);border-radius: px px px px;}.oxi-image-hover-wrapper-74 .oxi_carousel_dots{bottom: 0% !important;}.oxi-image-hover-wrapper-74 .oxi_carousel_dots .swiper-pagination-bullet:hover{background: rgb(119, 119, 119);}.oxi-image-hover-wrapper-74 .oxi_carousel_dots .swiper-pagination-bullet-active{background: #ab00c9;}@media only screen and (min-width : 669px) and (max-width : 993px){.oxi-image-hover-wrapper-74.oxi-addons-container .oxi-addons-row.oxi-addons-swiper-wrapper{width: 80%;}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows .oxi-icons{font-size:20px; line-height:20px;border-radius:px px px px;padding:10px 10px 10px 10px;}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows.oxi_carousel_prev{left:25px; right:auto;}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows.oxi_carousel_next{right:25px; left:auto}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows{top:50%; transform: translateY(-50%);}.oxi-image-hover-wrapper-74 .oxi_carousel_dots .swiper-pagination-bullet{width: 12px; height: 12px;margin: 3px;border-radius: px px px px;}.oxi-image-hover-wrapper-74 .oxi_carousel_dots{bottom: 25% !important;}}@media only screen and (max-width : 668px){.oxi-image-hover-wrapper-74.oxi-addons-container .oxi-addons-row.oxi-addons-swiper-wrapper{width: 80%;}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows .oxi-icons{font-size:20px; line-height:20px;border-radius:px px px px;padding:10px 10px 10px 10px;}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows.oxi_carousel_prev{left:25px; right:auto;}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows.oxi_carousel_next{right:25px; left:auto}.oxi-image-hover-wrapper-74 .oxi_carousel_arrows{top:50%; transform: translateY(-50%);}.oxi-image-hover-wrapper-74 .oxi_carousel_dots .swiper-pagination-bullet{width: 12px; height: 12px;margin: 3px;border-radius: px px px px;}.oxi-image-hover-wrapper-74 .oxi_carousel_dots{bottom: 25% !important;}}","font_family":"[]"},"child":[{"id":"110","styleid":"74","rawdata":"{\"oxi_image_comparison_image_one-select\":\"media-library\",\"oxi_image_comparison_image_one-image\":\"https:\\\/\\\/www.image-hover.oxilab.org\\\/wp-content\\\/uploads\\\/2020\\\/02\\\/pexels-photo-210019.png\",\"oxi_image_comparison_image_one-image-alt\":\"\",\"oxi_image_comparison_image_one-url\":\"https:\\\/\\\/www.shortcode-addons.com\\\/wp-content\\\/uploads\\\/2020\\\/01\\\/placeholder.png\",\"oxi_image_comparison_image_two-select\":\"media-library\",\"oxi_image_comparison_image_two-image\":\"https:\\\/\\\/www.image-hover.oxilab.org\\\/wp-content\\\/uploads\\\/2020\\\/02\\\/pexels-photo-210019-1.png\",\"oxi_image_comparison_image_two-image-alt\":\"\",\"oxi_image_comparison_image_two-url\":\"https:\\\/\\\/www.shortcode-addons.com\\\/wp-content\\\/uploads\\\/2020\\\/01\\\/placeholder.png\",\"oxi_image_comparison_body_offset-size\":\"0.5\",\"oxi_image_comparison_click\":\"false\",\"oxi_image_comparison_position\":\"true\",\"oxi_image_comparison_hover\":\"false\",\"shortcodeitemid\":\"19\"}"}]}',
                ],
            ],
        ];
        $this->pre_active = [
            'carousel-1',
        ];
    }

}
